unit Main;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, ComCtrls, SimpleTimer;

type
  TMainForm = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    Button1: TButton;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
    SimpleTimer1: TSimpleTimer;
    SimpleTimer2: TSimpleTimer;
    procedure TimerProc1(Sender: TObject);
    procedure TimerProc2(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

{--------------------- TMainForm ----------------------}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SimpleTimer1 := TSimpleTimer.Create(StrToInt(Edit1.Text), TimerProc1);
  SimpleTimer2 := TSimpleTimer.Create(StrToInt(Edit2.Text), TimerProc2);
{
  Alternative:
  
  SimpleTimer1 := TSimpleTimer.Create;
  SimpleTimer2 := TSimpleTimer.Create;
  SimpleTimer1.Interval := StrToInt(Edit1.Text);
  SimpleTimer2.Interval := StrToInt(Edit2.Text);
  SimpleTimer1.OnTimer := TimerProc1;
  SimpleTimer2.OnTimer := TimerProc2;
}
end;


procedure TMainForm.TimerProc1(Sender: TObject);
begin
  ListBox1.Items.Add('SimpleTimer1');
  ListBox1.ItemIndex := ListBox1.Items.Count -1;
end;


procedure TMainForm.TimerProc2(Sender: TObject);
begin
  ListBox1.Items.Add('SimpleTimer2');
  ListBox1.ItemIndex := ListBox1.Items.Count -1;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SimpleTimer1.Free;
  SimpleTimer2.Free;
end;


procedure TMainForm.Button1Click(Sender: TObject);
begin
  SimpleTimer1.Enabled := True;
end;


procedure TMainForm.Button2Click(Sender: TObject);
begin
  SimpleTimer2.Enabled := True;
end;


procedure TMainForm.Button3Click(Sender: TObject);
begin
  SimpleTimer1.Enabled := False;
end;


procedure TMainForm.Button4Click(Sender: TObject);
begin
  SimpleTimer2.Enabled := False;
end;


procedure TMainForm.Button5Click(Sender: TObject);
begin
  ListBox1.Clear;
end;


procedure TMainForm.Button6Click(Sender: TObject);
begin
  Close;
end;


procedure TMainForm.Edit1Change(Sender: TObject);
begin
  SimpleTimer1.Interval := StrToInt(Edit1.Text);
end;


procedure TMainForm.Edit2Change(Sender: TObject);
begin
  SimpleTimer2.Interval := StrToInt(Edit2.Text);
end;

end.

